﻿#region Copyright Syncfusion Inc. 2001 - 2007
//
//  Copyright Syncfusion Inc. 2001 - 2007. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;
using Syncfusion.Pdf.Tables;

namespace EssentialPDFSamples
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
        # region Private Members
        private System.Windows.Forms.Button button1;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.PictureBox pictureBox1;
        private Button button2;
        
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;
        # endregion

        # region Constructor
        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            Application.EnableVisualStyles();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.button1 = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.button2 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.BackColor = System.Drawing.Color.Transparent;
            this.button1.FlatAppearance.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(192)))), ((int)(((byte)(128)))));
            this.button1.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(224)))), ((int)(((byte)(192)))));
            this.button1.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
            this.button1.Image = ((System.Drawing.Image)(resources.GetObject("button1.Image")));
            this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.button1.Location = new System.Drawing.Point(76, 172);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 24);
            this.button1.TabIndex = 0;
            this.button1.Text = "Grid ";
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(0)))), ((int)(((byte)(64)))));
            this.label1.Location = new System.Drawing.Point(0, 120);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(373, 76);
            this.label1.TabIndex = 1;
            this.label1.Text = "Click the button to view an PDF document generated by Essential PDF.  Please note" +
    " that Adobe Reader or its equivalent is required to view the resultant document." +
    "";
            // 
            // pictureBox1
            // 
            this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(0, 0);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(373, 89);
            this.pictureBox1.TabIndex = 24;
            this.pictureBox1.TabStop = false;
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(184, 172);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(90, 23);
            this.button2.TabIndex = 25;
            this.button2.Text = "Light Table";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(373, 208);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.pictureBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Hello World";
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }
        #endregion

        # region Events
        private void button1_Click(object sender, System.EventArgs e)
        {
            //create a new pdf document

            PdfDocument doc = new PdfDocument();

            //create new page

            PdfPage page = doc.Pages.Add();


            Font ffont = new Font("Arial", 6, FontStyle.Regular);

            //create a new pdf font

            PdfFont font = new PdfTrueTypeFont(ffont, true);


            //create a pdfgrid

            PdfGrid grid = new PdfGrid();

            //add new row to grid

            grid.Rows.Add();

            grid.Rows[0].Height = 30;

            //add new column to grid

            grid.Columns.Add(10);

            PdfGridCellStyle style = new PdfGridCellStyle();

            style.Font = font;

            grid.Rows[0].Cells[0].Style = style;

            grid.Columns[0].Width = 150;

            grid.AllowRowBreakAcrossPages = true;

            //measure the string height

            SizeF size = font.MeasureString("Toto jeřetězec, který sycnfusion státy by změna velikosti");

            //layout format for the html element 
            PdfMetafileLayoutFormat format=new PdfMetafileLayoutFormat();
            format.Break=PdfLayoutBreakType.FitPage;
            format.Layout=PdfLayoutType.Paginate;

            //create the htmlelement 
            PdfHTMLTextElement htmlelement = new PdfHTMLTextElement("<html><body>Toto jeřetězec, <i>který sycnfusion státy</i> by změna velikosti</body></html>", font, PdfBrushes.Black);

            //draw the html element 
            htmlelement.Draw(page, new RectangleF(2, 5, size.Width, size.Height),format);
        
            //draw the grid to pdf
            grid.Draw(page, PointF.Empty);

            //save the pdf document

            doc.Save("Pdfgrid.pdf");

           //close the document

            doc.Close(true);

            //Message box confirmation to view the created PDF document.
            if (MessageBox.Show("Do you want to view the PDF file?", "PDF File Created",
                MessageBoxButtons.YesNo, MessageBoxIcon.Information)
                == DialogResult.Yes)
            {
                //Launching the PDF file using the default Application.[Acrobat Reader]
                System.Diagnostics.Process.Start("Pdfgrid.pdf");
                this.Close();
            }
            else
            {
                // Exit
                this.Close();
            }
        }

        # endregion

        private void button2_Click(object sender, EventArgs e)
        {
            //Create the document 
            PdfDocument doc = new PdfDocument();


            //add the page 
            PdfPage page=doc.Pages.Add();

            //Create the light table 
            PdfLightTable lighttable = new PdfLightTable();

            //Laod the data 
            lighttable.DataSource = CreateDatatable();

            //set width to the column 
            lighttable.Columns[0].Width = 50;

            //call the begin celllayout event 
            lighttable.BeginCellLayout+=lighttable_BeginCellLayout;

            //call the cell end layout event 
            lighttable.EndCellLayout += lighttable_EndCellLayout;

            //Draw the light table 
            lighttable.Draw(page, new RectangleF(0, 0, page.GetClientSize().Width, page.GetClientSize().Height));

            //save the pdf document 
            doc.Save("Pdflighttable.pdf");

            //close the document 
            doc.Close(true);

            System.Diagnostics.Process.Start("Pdflighttable.pdf");





        }

        void lighttable_EndCellLayout(object sender, EndCellLayoutEventArgs args)
        {
           //provide the code 
        }

        private void lighttable_BeginCellLayout(object sender, BeginCellLayoutEventArgs args)
        {
            if(  args.RowIndex==0 && args.CellIndex==0 )
            {
                Font ffont = new Font("Arial", 10, FontStyle.Regular);
                //create a new pdf font

                //create pdf font 
                PdfFont font = new PdfTrueTypeFont(ffont, true);
                
                //Html element 
                PdfHTMLTextElement htmlelement = new PdfHTMLTextElement("<html><body>Toto jeřetězec, <i>který sycnfusion státy</i> by změna velikosti</body></html>", font, PdfBrushes.Black);

                //draw the element in cell 0 
                htmlelement.Draw(args.Graphics,args.Bounds);

            }
        }

        private DataTable CreateDatatable()
        {
            //create the data table 
            DataTable table = new DataTable();

            //add the columns
            for (int i = 0; i < 5;i++ )
                table.Columns.Add();

            //Add the rows 

            table.Rows.Add(new object[] { " ", " ", " " });
            table.Rows.Add(new object[] { " ", " ", " " });

            return table;
        }
    }
}